/**
 * \file NVM_driver.c
 *
 * \brief NVMpײ ٰ
 *
 * ̧قNVMǂݏɕKvȊ֐܂݂܂B
 *
 * 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#include "NVM_driver.h"

/* TPIoRűNVMʒu̱ڽ𑗐M */
void send_nvm_address (volatile uint16_t nvm_address)
{
	tpi_send_byte(SSTPR);					// ڽ޲
	tpi_send_byte(((uint8_t)nvm_address & 0x00FF));
	tpi_send_byte(SSTPR | 0X01);			// ڽ޲
	tpi_send_byte((uint8_t)(nvm_address >>8));
}

/* TPIoRŎsNVM߂𑗐M */
void send_nvm_command (uint8_t nvm_command)
{
	tpi_send_byte(SOUT| ((NVMCMD & 0XF0)<<1) | (NVMCMD & 0X0F));
	tpi_send_byte(nvm_command);
}

/* TPIoRNVM1޲ēǂݍ */
uint8_t read_nvm_byte (void)
{
	uint8_t nvm_byte;

	tpi_send_byte(SLD_POSTINC);
	tpi_idle(idle_clock);
	nvm_byte = tpi_receive_byte();
	PORTD |=(1<<TPI_CLK)|(1<<TPI_DATA_TX);
	return nvm_byte;
}

/* TPIoRNVM1޲ď */
void write_nvm_word (volatile uint16_t nvm_byte)
{
	tpi_send_byte(SST_POSTINC);
	tpi_send_byte(nvm_byte & 0X00FF);
	tpi_send_byte(SST_POSTINC);
	tpi_send_byte(nvm_byte >> 8);
}
